﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;
using UnityEngine.SceneManagement;


// Both arena portraits are drawn here
// Player and Enemy stats are required to get head image
public class ArenaPortraits : MonoBehaviour {

    private setAppearance appearance;
    private setEnemyAppearance enemyAppearance;
    private PlayerStats stats; // to access name
    public Text playerName;
    public Image playerFace;
    public Image playerHead;
    private Color playerColor;
    public Text healthBar;
    public Image healthBarRed;
    public Text staminaBar;
    public Image staminaBarFull;
    //enemy
    private EnemyAI enemy;
    public Text enemyName;
    public Image enemyFace;
    public Image enemyHead;
    private Color enemyColor;
    public Text enemyHealthBar;
    public Image enemyHealthBarRed;
	public Text earnings;
	public GameObject rewardsPanel;
	private int reward;

    // Use this for initialization
    void Start () {
		rewardsPanel.SetActive (false);
        stats = GameObject.Find("Player").GetComponent<PlayerStats>();
        appearance = GameObject.Find("Player").GetComponent<setAppearance>();
        enemyAppearance = GameObject.Find("Enemy").GetComponent<setEnemyAppearance>();
        healthBarRed = GameObject.Find("playerHealthBar").GetComponent<Image>();
        staminaBarFull = GameObject.Find("playerStaminaBar").GetComponent<Image>();
        enemyHealthBarRed = GameObject.Find("enemyHealthBar").GetComponent<Image>();
        enemy = GameObject.Find("Enemy").GetComponent<EnemyAI>();
        // player
        playerColor = appearance.getColor();
        playerName.text = stats.getName();
        playerFace.sprite = appearance.getFace();
        playerHead.sprite = appearance.getHead();
        playerHead.color = playerColor;
        enemyPortrait();
		reward = Random.Range (20, 50);
    }

	// Update is called once per frame
	void Update () {
		if (EnemyAI.isEnemyDead) {
			displayEarnings ();
		}
        // manipulate player health bar
        if (PlayerStats.curHealth <= 0) {
            healthBarRed.enabled = false;
        }
        else {
            healthBarRed.enabled = true;
        }
        healthBar.text = PlayerStats.curHealth.ToString() + " / " + PlayerStats.maxHealth.ToString();
        healthBarRed.fillAmount = (float)PlayerStats.curHealth / PlayerStats.maxHealth;
        staminaBar.text = PlayerStats.stamina.ToString("F2") + " / " + PlayerStats.staminaMax.ToString("F2");
        staminaBarFull.fillAmount = (float)PlayerStats.stamina / PlayerStats.staminaMax;

        // manipulate enemy health bar
        if (enemy.enemyHealth <= 0) {
            enemyHealthBarRed.enabled = false;
        }
        else {
            enemyHealthBarRed.enabled = true;
        }
        enemyHealthBar.text = enemy.enemyHealth.ToString() + " / " + enemy.original;
        enemyHealthBarRed.fillAmount = (float)enemy.enemyHealth / enemy.original;
    }

    // have to call this from RandomAppearance or else this code executes before the random enemy is genertated.
    public void enemyPortrait() {
        enemyName.text = setEnemyAppearance.enemyName;
        enemyFace.sprite = setEnemyAppearance.face;
        enemyHead.sprite = setEnemyAppearance.head;
        enemyHead.color = setEnemyAppearance.color;
    }
		
	// When player is dead, this is called to display victory box
	public void displayEarnings(){
		rewardsPanel.SetActive (true);
		earnings.text = reward.ToString ();
	}
		
	 // Give reward to player
	 // Used when the "collect" button pushed
	public void getReward(){
		Money moneyScript = GameObject.Find("Canvas").GetComponent<Money>();
		moneyScript.increaseCoins (reward);
		SceneManager.LoadScene("Town01");
	}
}
